*:*********************************************************************
*:
*:        Program: MSGLINE.PRG
*:
*:         System: MIS Consulting
*:         Author: Charles Alan Butler
*:      Copyright (c) 1989, Charles Alan Butler
*:  Last modified: 05/29/89     10:21
*:
*:      Called by: DEMO.PRG                      
*:
*:      Documented 08/12/89 at 15:34                SNAP!  version 3.12f
*:*********************************************************************
**  prg to display a flashy message

PARAMETERS MsgColor,MsgRow,MsgTxt
**  MsgColor = <Text / Background>
**  Do MsgLine WITH MsgColor,MsgRow,MsgTxt

**  Requires variable 'wt' which is the WaitTime for delays, etc. (wt=90)
IF TYPE('WT') = 'U'
   wt=90
ENDIF
IF TYPE('SSpeed') = 'U'
   SSpeed=5
ENDIF

PRIVATE LeftCol,RightCol,TmpColor,OldRow,OldCol
OldRow = ROW()
OldCol = COL()
TmpColor=SYS(2001,'COLOR')   &&  Save Color

SET COLOR TO &MsgColor
@ MsgRow,0
DO CASE
CASE  LEN(MsgTxt)=0
   **  clear only
CASE  LEN(MsgTxt)>79
   @ MsgRow,0 SAY LEFT(MsgTxt,79)
OTHERWISE
   @ MsgRow,0 SAY SYS(2002)   && Hide Cursor
   LeftCol=40-LEN(MsgTxt)/2
   @ MsgRow,40-LEN(MsgTxt)/2 SAY MsgTxt
   RightCol=ROW()
   cnt1=MAX(wt/10,8)     &&  adjust message display time
   DO WHILE cnt1>0
      lc=0
      rc=79
      SET COLOR TO &MsgColor
      DO WHILE lc<LeftCol-1
         @ MsgRow,lc SAY CHR(16)
         @ MsgRow,rc SAY CHR(17)
         cnt2=IIF(LEN(MsgTxt)>50,10+SSpeed,6+SSpeed)  &&  adjust repeat rate
         DO WHILE cnt2>0
            IF INKEY()>0 .OR. cnt1<0
               lc=90
               cnt1=-1
               EXIT
            ENDIF
            cnt2=cnt2-1
         ENDDO
         lc=lc+1
         rc=rc-1
      ENDDO
      @ MsgRow,0 TO MsgRow,LeftCol-1 CLEAR
      @ MsgRow,rc+1 TO MsgRow,79 CLEAR
      cnt1=cnt1-1
   ENDDO
ENDCASE

SET COLOR TO &TmpColor
@ MsgRow,0
@ OldRow,OldCol SAY SYS(2002,1)   && Restore Cursor & reposition

RETURN
*: EOF: MSGLINE.PRG
